let print_option print_some o =
  Option.map_default print_some "None" o
;;

let print_list print_element l =
  Str.global_replace (Str.regexp ";$") "]"
    (List.fold_left
       (fun s e ->
          s ^ (print_element e) ^ ";")
       "[" l)
;;

let print_array print_element a =
  Str.global_replace (Str.regexp ";$") "|]"
    (Array.fold_left
       (fun s e ->
          s ^ (print_element e) ^ ";")
       "[|" a)
;;

let print_queue print_element q =
  Str.global_replace (Str.regexp ";$") "]"
    (Queue.fold
       (fun s e ->
          s ^ (print_element e) ^ ";")
       "Q[" q)
;;

let cmp_queue q q' =
  let queue_copy = Queue.copy q' in
    Queue.fold
      (fun result e ->
         let e' = Queue.take queue_copy in
           result && e = e')
      true
      q
;;

class test_serializable i1 i2 =
object(self : 'a)
  val mutable x = i1
  val mutable y = i2

  method get_x = x
  method get_y = y

  method cmp (o : 'a) =
    self # get_x = o # get_x && self # get_y = o # get_y

  method to_string () =
    Printf.sprintf "%d/%d" x y

  method from_string s =
    Scanf.sscanf s "%d/%d" (
      fun i1 i2 ->
        x <- i1;
        y <- i2
    )

end;;

let print_object (o : #Xnc_serialization.serializable) =
  o # to_string ()
;;

let cmp_object (o1 : test_serializable) (o2 : test_serializable) =
  o1 # cmp o2
;;

