class type serializable =
object
  method to_string : unit -> string
  method from_string : string -> unit
end;;

class ['a] generic_serializer
  (t : 'a)
  (serialize : 'a -> string)
  (deserialize : string -> 'a) =
object
  val mutable x = t
  val to_string = serialize
  val from_string = deserialize

  method get_value = x

  method to_string () =
    to_string x

  method from_string serialization =
    x <- from_string serialization

end;;

type common_config =
    { delimiter_char : char;
      escape_char : char;
      none_string : string;
      start_of_list : string;
      end_of_list : string;
      list_separator : string;
      name_value_separator : string;
      attribute_marker : string;
      prefix_separator : string
    }
;;

let default_config =
  { delimiter_char = '"';
    escape_char = '\\';
    none_string = "None";
    start_of_list = "[";
    end_of_list = "]";
    list_separator = ";";
    name_value_separator = "=";
    attribute_marker = "@";
    prefix_separator = ":"
  }
;;

