exception Token_evaluation_failed of string

class type ['a] token_evaluator =
object
  method get_int :
    ?properties:Xnc_property.properties ->
    'a -> int
  method get_float :
    ?properties:Xnc_property.properties ->
    'a -> float
  method get_char :
    ?properties:Xnc_property.properties ->
    'a -> char
  method get_bool :
    ?properties:Xnc_property.properties ->
    'a -> bool
  method get_string :
    ?properties:Xnc_property.properties ->
    'a -> string
  method get_date :
    ?properties:Xnc_property.properties ->
    'a -> Netdate.t
end

class standard_evaluator
  ?(config = Xnc_serialization.default_config) () : [string] token_evaluator =
object(self)
  method get_int ?properties token =
    self # parse_value token int_of_string "to int"

  method get_float ?properties token =
    self # parse_value token float_of_string "to float"

  method get_char ?properties token =
    self # parse_value token (fun t -> t.[0]) "to char"

  method get_bool ?properties token =
    self # parse_value token bool_of_string "to bool"

  method get_string ?properties token =
    token

  method get_date ?properties token =
    Netdate.parse token

  method private parse_value :
      'a. string -> (string -> 'a) -> string -> 'a =
    fun token parse_token type_name ->
      try
        parse_token token
      with _ ->
        raise (Token_evaluation_failed
                 (Printf.sprintf 
                    "error trying to convert \"%s\" %s"
                    token
                    type_name))

end;;

