open OUnit

module Test_conf =
struct
  type key = string
  type item = int

  let interval = 1.
end;;

module Test_cache_manager =
    Xnc_cache_manager.Make
      (Test_conf)
      (Xnc_core.Null_mutex)
      (Xnc_scheduler.Null)
;;

(* tests *)
let test_get_cache _ =
  let cache = Test_cache_manager.get_cache () in
    Test_cache_manager.Cache.insert cache "value" 10;
    OUnit.assert_equal
      ~printer:string_of_int
      ~msg:"Unexpected cache content"
      10
      (Test_cache_manager.Cache.get cache "value");
    Test_cache_manager.Cache.insert cache "value" 20;
    OUnit.assert_equal
      ~printer:string_of_int
      ~msg:"Unexpected cache content"
      20
      (Test_cache_manager.Cache.get cache "value");
;;

(* test suite *)
let suite = "Cache manager test" >:::
  ["test_get_cache" >:: test_get_cache]
;;


