open OUnit

(* tests *)
let test_socket _ =
  let socket_address = (Unix.ADDR_UNIX "/tmp/local_socket") in
  let socket = Xnc_socket.make socket_address in
    Xnc_socket.listen socket 3;
    Unix.access "/tmp/local_socket" [Unix.F_OK];
    Xnc_socket.close socket socket_address;
    OUnit.assert_raises
      ~msg:"Exception Unix_error not raised"
      (Unix.Unix_error(Unix.ENOENT, "access", "/tmp/local_socket"))
      (fun () -> Unix.access "/tmp/local_socket" [Unix.F_OK])
;;

(* test suite *)
let suite = "Socket test" >:::
  ["test_socket" >:: test_socket]
;;

