type handler = unit -> unit;;

(* TODO: choose the right data structure *)
type 'e t = ('e, handler) Hashtbl.t;;

let create ?(size = 4) () =
  Hashtbl.create size
;;

let count r =
  Hashtbl.length r
;;

let add_handler r event callback =
  Hashtbl.add r event callback
;;

let extract_callback_list r event =
  let rev_callback_list = Hashtbl.find_all r event in
    List.rev rev_callback_list
;;

let invoke r event =
  List.iter
    (fun callback -> callback ())
    (extract_callback_list r event)
;;

