module type INITIALIZABLE =
sig
  type t

  val create : unit -> t
end;;

module type LOCKABLE =
sig
  type t

  val create : unit -> t
  val lock : t -> unit
  val unlock : t -> unit
end;;

module Null_mutex : LOCKABLE =
struct
  type t = unit

  let create () = ()
  let lock l = ()
  let unlock l = ()
end;;


