let make socket_address =
  let domain = Unix.domain_of_sockaddr socket_address
  and default_protocol = 0 in
  let socket = Unix.socket domain Unix.SOCK_STREAM default_protocol in
    Unix.bind socket socket_address;
    (match socket_address with
       | Unix.ADDR_UNIX(file_name) -> Unix.chmod file_name 0o777
       | _ -> ());
    socket
;;

let listen socket max_connections =
  Unix.listen socket max_connections;
;;

let close socket socket_address =
  Unix.shutdown socket Unix.SHUTDOWN_SEND;
  Unix.close socket;
  match socket_address with
    | Unix.ADDR_UNIX(file_name) -> Sys.remove file_name
    | _ -> ()
;;

