(** Sockets
  *
  * This module provides a simple interface to manage sockets.
  *)

val make : Unix.sockaddr -> Unix.file_descr
(** [make s] returns the file descriptor of the socket created and bound to
  * socket address [s]. *)

val listen : Unix.file_descr -> int -> unit
(** [listen s m] listens for connections on socket [s], queuing at most [m]
  * incoming connections. *)

val close : Unix.file_descr -> Unix.sockaddr -> unit
(** [close d s] closes the file descriptor [d], after shutting the connection
  * down. Removes the associated file if socket address [s] is a Unix address.
  *)

