let fold ?(test = (fun _ -> true)) ~f a stream =
  let rec loop accu =
    let v = Stream.next stream in
      if test v then
        begin
          let (accu, exit) = f v accu in
            if exit then
              accu
            else
              loop accu
        end
      else
        accu
  in
    loop a
;;

let fold2 ?(test = (fun _ _ -> true)) ~f a s1 s2 =
  let rec loop accu =
    let v1 = Stream.next s1 in
    let v2 = Stream.next s2 in
      if test v1 v2 then
        begin
          let (accu, exit) = f v1 v2 accu in
            if exit then
              accu
            else
              loop accu
        end
      else
        accu
  in
    loop a
;;

let for_loop ?test ~f stream =
  fold ?test
    ~f:(fun v _ ->
          let exit = f v in
            ((), exit))
    () stream
;;

let for2 ?test ~f s1 s2 =
  fold2 ?test
    ~f:(fun v1 v2 _ ->
          let exit = f v1 v2 in
            ((), exit))
    () s1 s2
;;

