(** Page helper.
  *
  * This module provides some helper functions. *)

val text : string -> string
(** [text s] returns the XML escaped version of string [s]. *)

class name_value_table :
  string ->
  (unit -> (string * string) list) ->
  Srv_page_element.page_element
(** [new name_value_table l f] returns a page element that renders name/value
  * tables. Label [l] is specifies the table caption, function [f] is evaluated
  * at rendering time to obtain the name/value list to display. *)

class misc_info :
  Srv_runtime_context.context ->
  Netcgi.cgi_activation ->
  Srv_page_element.page_element
(** [new misc_info c a] returns a page element that renders information
  * contained in context [c] and CGI activation [a]. *)

val create_page_logger : unit -> Xnc_logger.t
(** [create_page_logger ()] creates a page logger that collects trace messages
  * written by pages. *)

class trace_table :
  Netcgi.cgi_activation ->
  Xnc_logger.t ->
  Srv_page_element.page_element
(** [new misc_info c a] returns a page element that renders the messages
  * collected by page logger. *)

