(** Resource list.
  *
  * This module provides functions to retrieve available resources. *)

type resource =
  { name : string;
    resource_type : string
  }
(** The type of resources. *)

type t
(** The type of resource list. *)

val create : resource list -> t
(** [create l] returns a value of type [t], starting from a [list] of
  * resources. *)

val get_name_list : t -> string list
(** [get_name_list l] returns a list of the names of available resources. *)

val get_filtered_name_list : (resource -> bool) -> t -> string list
(** [get_filtered_name_list l c] returns a filtered list of the names of
  * available resources that matches condition [c]. *)

val get_page_name_list : t -> string list
(** [get_page_name_list l] returns a list of the names of pages. *)

