module Make
  (Page_parameters : Srv_types.PAGE_PARAMETERS)
  (Page_behavior : Srv_page_behavior.PAGE_BEHAVIOR
     with type page_parameter_type = Page_parameters.t) =
struct

  class virtual not_found_page_base
    page_name
    page_context =
  object(self)
    inherit Page_behavior.page_behavior_base
          page_name
          Page_parameters.default_not_found_page_parameters
          page_context as super

    method private get_missing_resource =
      Page_parameters.get_missing_resource
        (self # get_page_parameters)

    method init () =
      self # register_callback
        Srv_types.Pre_render
        (fun () ->
           self # get_cgi_context # out_channel # rollback_work ();
           Srv_page_structure.set_http_status
             self # get_page_structure
             `Not_found
        )

    method build_validator_collection () =
      ()

    method read_user_input () =
      ()

  end

  class standard_not_found_page
    page_context =
  object(self)
    inherit not_found_page_base
          "standard_not_found_page.xnunc"
          page_context

    method build_page_structure parameters =
      (* Head element *)
      let head = new Srv_page_element.head_element in
        Srv_page_structure.add_element (self # get_page_structure) head;
        Srv_page_structure.add_element head
          (new Srv_page_element.literal_element
             "<title>Ex-nunc not found page</title>\
              <link rel=\"stylesheet\" \
                    type=\"text/css\" \
                    href=\"/ex-nunc/style.css\" />");

      (* Body element *)
      let body = Srv_page_structure.create_body_element
                   (self # get_page_structure) in

      let add e content = Srv_page_structure.add_element
                            e
                            (new Srv_page_element.literal_element content) in

        add body "<h1>Not found</h1>\
                    <p>Missing resource:<br />\
                      <tt>";

        add body (Srv_page_helper.text (self # get_missing_resource));

        add body "</tt><br /></p>";

  end

end;;

