type t =
    { table : (string, Srv_input_validator.input_validator) Hashtbl.t;
      mutable stack : Srv_input_validator.input_validator list
    }
;;

let create ?(size = 4) () =
  { table = Hashtbl.create size;
    stack = []
  }
;;

let count c =
  Hashtbl.length c.table
;;

let add_validator c label validator =
  Hashtbl.add c.table label validator;
  c.stack <- validator :: c.stack
;;

let is_valid c =
  List.fold_left
    (fun valid validator ->
       valid && validator # is_valid ())
    true
    c.stack
;;

let error_message_list c =
  List.fold_left
    (fun message_list validator ->
       if not (validator # is_valid ()) then
         validator # get_error_message :: message_list
       else
         message_list)
    []
    c.stack
;;

let find_validator c label =
  Hashtbl.find c.table label
;;

