let create_test_activation
      ?script_name
      ?path_info
      ?server_software
      args =
  let properties =
    match script_name with
        None -> []
      | Some v -> [("SCRIPT_NAME", v)] in
  let properties =
    match path_info with
        None -> properties
      | Some v -> ("PATH_INFO", v) :: properties in
  let properties =
    match server_software with
        None -> properties
      | Some v -> ("SERVER_SOFTWARE", v) :: properties in
  let properties =
      ("SERVER_PROTOCOL", "HTTP/1.1") :: properties in
  let env = new Netcgi_common.cgi_environment
              ~config:Netcgi.default_config
              ~properties
              ~input_header:[]
              (new Netchannels.output_null ()) in
    new Netcgi_common.cgi
      env
      (`Direct "")
      `GET
      args
;;

let render_to_buffer render =
  let buf = Buffer.create 128 in
  let ch = new Netchannels.output_buffer buf in
  let trans_ch = new Netchannels.buffered_trans_channel ch in
    render trans_ch;
    trans_ch # commit_work ();
    trans_ch # close_out ();
    Buffer.contents buf
;;

let render_element (e : #Srv_page_element.page_element) =
  render_to_buffer
    (fun ch ->
       e # render ch)
;;

let render_page page = 
  render_to_buffer
    (fun ch ->
       Srv_page_structure.render page ch)
;;

