open OUnit

module Concrete_page_behavior = Test_page_behavior.Concrete_page_behavior;;

(* tests *)
let test_add_page_constructor _ =
  let repository = Concrete_page_behavior.Factory.create () in
  let repository = Concrete_page_behavior.Factory.add_page_constructor
                     repository
                     "test_page.xnunc"
                     (new Test_page_behavior.test_page) in
    OUnit.assert_equal
      ~printer:(fun a -> string_of_int a)
      ~msg:"Unexpected number of pages"
      1
      (Concrete_page_behavior.Factory.count repository)
;;

let test_find_page_constructor _ =
  let repository = Concrete_page_behavior.Factory.create () in
  let repository = Concrete_page_behavior.Factory.add_page_constructor
                     repository
                     "test_page.xnunc"
                     (new Test_page_behavior.test_page) in
    OUnit.assert_raises
      ~msg:"Exception Not_found not raised"
      Not_found
      (fun () -> Concrete_page_behavior.Factory.find_page_constructor
                   repository
                   "none.xnunc");
;;

(* test suite *)
let suite = "Page repository test" >:::
  ["test_add_page_constructor" >:: test_add_page_constructor;
   "test_find_page_constructor" >:: test_find_page_constructor]
;;

