open OUnit

module Concrete_resource_list_builder =
struct
  type t = Srv_resource_list.t

  let create () =
    Srv_resource_list.create
      [
        { Srv_resource_list.name = "test_page.xnunc";
          Srv_resource_list.resource_type = "xnc:page"
        };
        { Srv_resource_list.name = "error_page.xnunc";
          Srv_resource_list.resource_type = "xnc:page"
        }
      ]

end;;

module Concrete_request_processor =
  Srv_request_processor.Make
    (struct
       let create () =
         { Srv_runtime_context.default_context with
               Srv_runtime_context.logger = Xnc_logger.create ()
         }
       let update =
         Srv_runtime_context.Default_context_builder.update
     end)
    (Test_runtime_context.Runtime_context)
    (Test_page_dispatcher.Concrete_page_dispatcher)
    (Test_page_factory_builder.Concrete_page_factory_builder)
    (Concrete_resource_list_builder)
;;

(* tests *)
let test_set_up _ =
  let context = Concrete_request_processor.set_up () in
    OUnit.assert_equal
      ~printer:Std.identity
      ~msg:"Unexpected version"
      "0.0.1"
      (context.Srv_runtime_context.application_values.Srv_values.version);
;;

(* test suite *)
let suite = "Request processor test" >:::
  ["test_set_up" >:: test_set_up]
;;

