open OUnit

(* tests *)
let test_increment_total_requests _ =
  let statistics = Srv_statistics.default_counters in
  let new_statistics = Srv_statistics.increment_total_requests statistics in
    OUnit.assert_equal
      ~printer:string_of_int
      ~msg:"Unexpected total requests"
      (succ statistics.Srv_statistics.total_requests)
      (new_statistics.Srv_statistics.total_requests);
;;

let test_increment_total_errors _ =
  let statistics = Srv_statistics.default_counters in
  let new_statistics = Srv_statistics.increment_total_errors statistics in
    OUnit.assert_equal
      ~printer:string_of_int
      ~msg:"Unexpected total errors"
      (succ statistics.Srv_statistics.total_errors)
      (new_statistics.Srv_statistics.total_errors);
;;

(* test suite *)
let suite = "Page state test" >:::
  ["test_increment_total_requests" >:: test_increment_total_requests;
   "test_increment_total_errors" >:: test_increment_total_errors]
;;

