open OUnit

(* Collect the tests of different modules into one test suite *)
let suite = "Application server test suite" >::: 
  [Test_page_structure.suite;
   Test_page_element.suite;
   Test_page_factory.suite;
   Test_page_state_machine.suite;
   Test_page_behavior.suite;
   Test_page_helper.suite;
   Test_configuration_loader.suite;
   Test_configuration.suite;
   Test_types.suite;
   Test_input_validator.suite;
   Test_validator_collection.suite;
   Test_runtime_context.suite;
   Test_page_factory_builder.suite;
   Test_page_state.suite;
   Test_statistics.suite;
   Test_state_persisting.suite;
   Test_state.suite;
   Test_resource_list.suite;
   Test_request_processor.suite;
   Test_page_dispatcher.suite;
   Test_sqlite3_state.suite]
;;

let _ =
  OUnit.run_test_tt_main suite
;;

