(*******************************************************************************
 * This file is "_xnunc_build/form_page.ml"
 *
 * Automatically generated on 2008-07-20 19:23:12
 *
 * PLEASE DO NOT EDIT
 ******************************************************************************)

(******************************************************************************)
(**************************  GLOBAL SCRIPT SECTION  ***************************)
(******************************************************************************)


(******************************************************************************)
(****************************  FORM DATA SECTION  *****************************)
(******************************************************************************)
module Form_data =
struct
  type t =
      {
        int_field : int;
        float_field : float;
        char_field : char;
        string_field : string;
        bool_field : bool;
      }

  let create () =
    {
      int_field = 10;
      float_field = 0.25;
      char_field = 'q';
      string_field = "test";
      bool_field = true;
    }

  let from_cgi_context (cgi : Netcgi.cgi_activation) =
    let int_field = int_of_string (cgi # argument_value "int_field") in
    let float_field = float_of_string (cgi # argument_value "float_field") in
    let char_field = String.get (cgi # argument_value "char_field") 0 in
    let string_field = Std.identity (cgi # argument_value "string_field") in
    let bool_field = bool_of_string (cgi # argument_value "bool_field") in
      {
        int_field = int_field;
        float_field = float_field;
        char_field = char_field;
        string_field = string_field;
        bool_field = bool_field;
      }
end

(******************************************************************************)
(***************************  CLASS HEADER SECTION  ***************************)
(******************************************************************************)
class form_page page_context =
object(self)
  inherit Page_modules.Page_behavior.page_behavior_base
        "form_page" Page_parameters.default_form_page_page_parameters
        page_context

  val mutable form_data = Form_data.create ()

(******************************************************************************)
(**********************  VALIDATORS COLLECTION SECTION  ***********************)
(******************************************************************************)
  method build_validator_collection () =
    self#add_validator
      "int_field"
      (new Srv_input_validator.type_validator
         (self#get_cgi_context#argument_value "int_field")
         "int"
         "Invalid int value");
    self#add_validator
      "float_field"
      (new Srv_input_validator.type_validator
         (self#get_cgi_context#argument_value "float_field")
         "float"
         "Invalid float value");
    self#add_validator
      "char_field"
      (new Srv_input_validator.type_validator
         (self#get_cgi_context#argument_value "char_field")
         "char"
         "Invalid char value");
    self#add_validator
      "string_field"
      (new Srv_input_validator.required_field_validator
         (self#get_cgi_context#argument_value "string_field")
         "Required field");
    self#add_validator
      "bool_field"
      (new Srv_input_validator.type_validator
         (self#get_cgi_context#argument_value "bool_field")
         "bool"
         "Invalid bool value");

(******************************************************************************)
(*************************  CONSTANT METHODS SECTION  *************************)
(******************************************************************************)
  method read_user_input () =
    form_data <- Form_data.from_cgi_context (self#get_cgi_context)

(******************************************************************************)
(***************************  CLASS SCRIPT SECTION  ***************************)
(******************************************************************************)
(******************************************************************************)
(*******************  BUILD_PAGE_STRUCTURE METHOD SECTION  ********************)
(******************************************************************************)
  method build_page_structure parameters =
    (* Set attributes *)
    self#get_page_structure#set_xml_version "1.0";
    self#get_page_structure#set_encoding "ISO-8859-1";
    self#get_page_structure#set_dtd "xhtml1-transitional";
    self#get_page_structure#set_debug false;

  let document_1_standard_page_0_head = new Srv_page_element.head_element in
    Srv_page_structure.add_element (self#get_page_structure) document_1_standard_page_0_head;

(* Expanding CDATA block document_1_standard_page_0_head_0_cdata *)
    let document_1_standard_page_0_head_0_cdata = new Srv_page_element.literal_element "
    <title>Ex-nunc demo</title>
    <link rel=\"stylesheet\" type=\"text/css\" href=\"/ex-nunc/style.css\" />
  " in
    Srv_page_structure.add_element document_1_standard_page_0_head document_1_standard_page_0_head_0_cdata;

  let body = Srv_page_structure.create_body_element (self#get_page_structure) in

(* Expanding CDATA block body_0_cdata *)
    let body_0_cdata = new Srv_page_element.literal_element "
      <h1>Ex-nunc form handling demo</h1>
      <p>
        Here is a form where you can test the validation features. 
        Every field has an associated validator, that tests if the 
        value can be converted to the right type. E.g.: the 
        <code>int_field</code> accepts only integer values.
      </p>
      " in
    Srv_page_structure.add_element body body_0_cdata;

(* Expanding form element form *)
let form = Srv_page_structure.create_form_element (self#get_page_structure) (self#get_cgi_context) in

  form#set_enctype (Some "application/x-www-form-urlencoded");
(* form_data#render_main_page: nothing to do here *)

(* Expanding CDATA block form_1_cdata *)
    let form_1_cdata = new Srv_page_element.literal_element "

        <fieldset>
          <legend>Form example</legend>

          <label for=\"int_field\">int_field:</label>
          " in
    Srv_page_structure.add_element form form_1_cdata;

(* Rendering XHTML input element "int_field" *)
let int_field =
  new Srv_page_element.literal_element
    ("<input type=\"text\"
             name=\"int_field\"
             id=\"int_field\"
             value=\"" ^
     (Srv_page_helper.text (
       if self#is_first_invocation
       then
         string_of_int form_data.Form_data.int_field
       else
         self#get_cgi_context#argument_value "int_field"
     )) ^ "\" />") in
  Srv_page_structure.add_element form int_field;

(* Rendering validator element "form_3_validator" *)
if (not self#is_first_invocation)
then
  begin
    let form_3_validator =
      Srv_validator_collection.find_validator
        (self#get_validator_collection)
        "int_field" in
      Srv_page_structure.add_element
        form
        (new Srv_page_element.validator_element form_3_validator)
  end
else
  ();

(* Expanding CDATA block form_4_cdata *)
    let form_4_cdata = new Srv_page_element.literal_element "
          <br/>


          <label for=\"float_field\">float_field:</label>
          " in
    Srv_page_structure.add_element form form_4_cdata;

(* Rendering XHTML input element "float_field" *)
let float_field =
  new Srv_page_element.literal_element
    ("<input type=\"text\"
             name=\"float_field\"
             id=\"float_field\"
             value=\"" ^
     (Srv_page_helper.text (
       if self#is_first_invocation
       then
         string_of_float form_data.Form_data.float_field
       else
         self#get_cgi_context#argument_value "float_field"
     )) ^ "\" />") in
  Srv_page_structure.add_element form float_field;

(* Rendering validator element "form_6_validator" *)
if (not self#is_first_invocation)
then
  begin
    let form_6_validator =
      Srv_validator_collection.find_validator
        (self#get_validator_collection)
        "float_field" in
      Srv_page_structure.add_element
        form
        (new Srv_page_element.validator_element form_6_validator)
  end
else
  ();

(* Expanding CDATA block form_7_cdata *)
    let form_7_cdata = new Srv_page_element.literal_element "
          <br/>


          <label for=\"char_field\">char_field:</label>
          " in
    Srv_page_structure.add_element form form_7_cdata;

(* Rendering XHTML input element "char_field" *)
let char_field =
  new Srv_page_element.literal_element
    ("<input type=\"text\"
             name=\"char_field\"
             id=\"char_field\"
             value=\"" ^
     (Srv_page_helper.text (
       if self#is_first_invocation
       then
         Printf.sprintf "%c" form_data.Form_data.char_field
       else
         self#get_cgi_context#argument_value "char_field"
     )) ^ "\" />") in
  Srv_page_structure.add_element form char_field;

(* Rendering validator element "form_9_validator" *)
if (not self#is_first_invocation)
then
  begin
    let form_9_validator =
      Srv_validator_collection.find_validator
        (self#get_validator_collection)
        "char_field" in
      Srv_page_structure.add_element
        form
        (new Srv_page_element.validator_element form_9_validator)
  end
else
  ();

(* Expanding CDATA block form_10_cdata *)
    let form_10_cdata = new Srv_page_element.literal_element "
          <br/>


          <label for=\"string_field\">string_field:</label>
          " in
    Srv_page_structure.add_element form form_10_cdata;

(* Rendering XHTML input element "string_field" *)
let string_field =
  new Srv_page_element.literal_element
    ("<input type=\"text\"
             name=\"string_field\"
             id=\"string_field\"
             value=\"" ^
     (Srv_page_helper.text (
       if self#is_first_invocation
       then
          form_data.Form_data.string_field
       else
         self#get_cgi_context#argument_value "string_field"
     )) ^ "\" />") in
  Srv_page_structure.add_element form string_field;

(* Rendering validator element "form_12_validator" *)
if (not self#is_first_invocation)
then
  begin
    let form_12_validator =
      Srv_validator_collection.find_validator
        (self#get_validator_collection)
        "string_field" in
      Srv_page_structure.add_element
        form
        (new Srv_page_element.validator_element form_12_validator)
  end
else
  ();

(* Expanding CDATA block form_13_cdata *)
    let form_13_cdata = new Srv_page_element.literal_element "
          <br/>


          <label for=\"bool_field\">bool_field:</label>
          " in
    Srv_page_structure.add_element form form_13_cdata;

(* Rendering XHTML input element "bool_field" *)
let bool_field =
  new Srv_page_element.literal_element
    ("<input type=\"text\"
             name=\"bool_field\"
             id=\"bool_field\"
             value=\"" ^
     (Srv_page_helper.text (
       if self#is_first_invocation
       then
         string_of_bool form_data.Form_data.bool_field
       else
         self#get_cgi_context#argument_value "bool_field"
     )) ^ "\" />") in
  Srv_page_structure.add_element form bool_field;

(* Rendering validator element "form_15_validator" *)
if (not self#is_first_invocation)
then
  begin
    let form_15_validator =
      Srv_validator_collection.find_validator
        (self#get_validator_collection)
        "bool_field" in
      Srv_page_structure.add_element
        form
        (new Srv_page_element.validator_element form_15_validator)
  end
else
  ();

(* Expanding CDATA block form_16_cdata *)
    let form_16_cdata = new Srv_page_element.literal_element "
          <br/>

          " in
    Srv_page_structure.add_element form form_16_cdata;

(* Rendering validation_summary element "validation_summary" *)
let validation_summary =
  new Srv_page_element.validation_summary
    (self#get_validator_collection)
    "Error summary:" in
  Srv_page_structure.add_element
    form
    (validation_summary :> Srv_page_element.page_element);

let submit_button = new Srv_page_element.button_element "Submit" in
Srv_page_structure.add_element
  form
    (submit_button :> Srv_page_element.page_element);

(* Expanding CDATA block form_19_cdata *)
    let form_19_cdata = new Srv_page_element.literal_element "
        </fieldset>

        " in
    Srv_page_structure.add_element form form_19_cdata;

(* Expanding processing instruction form_20_proc_instruction *)

          let add form s =
            Srv_page_structure.add_element form
            (new Srv_page_element.literal_element s) in

          let is_valid = self # is_valid () in
            if (not self # is_first_invocation) then
              begin
                add form ("<h2>Submitted data</h2>\
                           <p>The values you entered are " ^
                          (if is_valid
                           then "<strong>valid</strong>"
                           else "<strong>not valid</strong>. The fields \
                                 maintain their default values") ^
                          ":<br />");
                add form ("int_field = " ^
                          (string_of_int form_data.Form_data.int_field) ^
                          "<br />");
                add form ("float_field = " ^
                          (string_of_float form_data.Form_data.float_field) ^
                          "<br />");
                add form ("char_field = " ^
                          (Std.string_of_char form_data.Form_data.char_field) ^
                          "<br />");
                add form ("string_field = " ^
                          (Srv_page_helper.text form_data.Form_data.string_field) ^
                          "<br />");
                add form ("bool_field = " ^
                          (string_of_bool form_data.Form_data.bool_field) ^
                          "<br />");
                add form ("</p>")
          
              end
            else
              ();
        
(* Expanding processing instruction form_21_proc_instruction *)

            (* This is an example of "print" processing instruction *)
            let my_string = "Return to the demo page" in
        
(* Expanding CDATA block form_22_cdata *)
    let form_22_cdata = new Srv_page_element.literal_element "
        <h2>" in
    Srv_page_structure.add_element form form_22_cdata;

(* Expanding print processing instruction form_23_print_proc_instruction *)
    let form_23_print_proc_instruction = new Srv_page_element.literal_element ( my_string ) in
    Srv_page_structure.add_element form form_23_print_proc_instruction;

(* Expanding CDATA block form_24_cdata *)
    let form_24_cdata = new Srv_page_element.literal_element "</h2>
        <!-- A *very* useless print processing instruction -->
        <p>" in
    Srv_page_structure.add_element form form_24_cdata;

(* Expanding print processing instruction form_25_print_proc_instruction *)
    let form_25_print_proc_instruction = new Srv_page_element.literal_element ( "This button will" ) in
    Srv_page_structure.add_element form form_25_print_proc_instruction;

(* Expanding CDATA block form_26_cdata *)
    let form_26_cdata = new Srv_page_element.literal_element " make you return to the demo start page:<br />
          " in
    Srv_page_structure.add_element form form_26_cdata;

let back_button = new Srv_page_element.button_element "Back" in

(* Expanding onclick element back_button_0_onclick *)
back_button#add_click_handler
(fun () ->
self#set_target_page
  ~on_invalid_input:
   (Page_modules.Page_behavior.Goto
    ("start_page", (Page_parameters.create_start_page_page_parameters)))


  (Page_modules.Page_behavior.Goto
    ("start_page", (Page_parameters.create_start_page_page_parameters)))
);

Srv_page_structure.add_element
  form
    (back_button :> Srv_page_element.page_element);

(* Expanding CDATA block form_28_cdata *)
    let form_28_cdata = new Srv_page_element.literal_element "
        </p>
      " in
    Srv_page_structure.add_element form form_28_cdata;

(* Expanding processing instruction body_2_proc_instruction *)

        Srv_page_structure.add_element
          body
          (new Footer.footer);
      
(******************************************************************************)
(***************************  CLASS FOOTER SECTION  ***************************)
(******************************************************************************)
end;;

