(*******************************************************************************
 * This file is "_xnunc_build/page_parameters.ml"
 *
 * Automatically generated on 2008-07-20 18:40:03
 *
 * PLEASE DO NOT EDIT
 ******************************************************************************)

type t =
  | No_parameters
  | Error_page_parameters of string
  | Debug_page_page_parameters of int * string
(*| Page "error_page" has no parameters *)
(*| Page "form_page" has no parameters *)
  | Param_page_page_parameters of int * float
(*| Page "quit_page" has no parameters *)
(*| Page "session_page" has no parameters *)
(*| Page "start_page" has no parameters *)
;;

let create_no_page_parameters () =
  No_parameters
;;

let create_error_page_parameters error_description =
  Error_page_parameters error_description
;;
  
let default_error_page_parameters =
  create_error_page_parameters ""
;;

let default_debug_page_page_parameters =
  Debug_page_page_parameters (42, "test")
;;

let default_form_page_page_parameters =
  No_parameters
;;
let default_param_page_page_parameters =
  Param_page_page_parameters (0, 0.)
;;
let default_quit_page_page_parameters =
  No_parameters
;;
let default_session_page_page_parameters =
  No_parameters
;;
let default_start_page_page_parameters =
  No_parameters
;;

let get_error_description parameters =
  match parameters with
      Error_page_parameters error -> error
    | _ -> raise Srv_types.Invalid_page_parameters
;;

let to_field_collection parameters =
  let fc = Xnc_field_collection.create "Parameters" in
  let _ = match parameters with
      No_parameters ->
        ()
    | Error_page_parameters error ->
        Xnc_field_collection.register_string fc "error" error
    | Debug_page_page_parameters (int_param, string_param) ->
        Xnc_field_collection.register_int fc "int_param" int_param;
        Xnc_field_collection.register_string fc "string_param" string_param;
    | Param_page_page_parameters (int_param, float_param) ->
        Xnc_field_collection.register_int fc "int_param" int_param;
        Xnc_field_collection.register_float fc "float_param" float_param;
  in
    fc
;;

let from_field_collection parameters fc =
  match parameters with
      No_parameters as p ->
        p
    | Error_page_parameters _ ->
        let error = Xnc_field_collection.get_string fc "error" in
          (Error_page_parameters error)
    | Debug_page_page_parameters _ ->
        let int_param = Xnc_field_collection.get_int fc "int_param" in
        let string_param = Xnc_field_collection.get_string fc "string_param" in
          (Debug_page_page_parameters (int_param, string_param))
    | Param_page_page_parameters _ ->
        let int_param = Xnc_field_collection.get_int fc "int_param" in
        let float_param = Xnc_field_collection.get_float fc "float_param" in
          (Param_page_page_parameters (int_param, float_param))
;;

let create_debug_page_page_parameters int_param string_param =
  Debug_page_page_parameters (int_param, string_param);;

let create_error_page_page_parameters error_description =
  Error_page_parameters error_description;;

let create_form_page_page_parameters = No_parameters;;

let create_param_page_page_parameters int_param float_param =
  Param_page_page_parameters (int_param, float_param);;

let create_quit_page_page_parameters = No_parameters;;

let create_session_page_page_parameters = No_parameters;;

let create_start_page_page_parameters = No_parameters;;

