DEFINE CAST_OR_ERROR (memo, obj, loc) =
  try
    memo#find obj
  with Not_found ->
    raise (Codegen_common.Cast_error (Codegen_common.location loc))

DEFINE FIND (element_tag) =
  let f acc t =
    let obj = Tree.get_data t in
      match obj#tag with
        | element_tag -> obj::acc
        | _ -> acc in
    Tree.depth_first_fold f [] t |> List.rev

DEFINE FIND_UNIQUE (element_tag) =
  let f acc t =
    let obj = Tree.get_data t in
      match obj#tag with
        | element_tag -> obj::acc
        | _ -> acc in
    try Some (Tree.depth_first_fold f [] t |> List.hd)
    with Failure "hd" -> None

