INCLUDE "../camlp4_macros.ml"

open Camlp4.PreCast
open Xnc_functional
open Common_types
open Codegen_common

class field depth idx parsed_element parent_obj node =
object (self)
  inherit Elements.element depth idx parsed_element parent_obj node

  val module_name = "Field"
  val class_name = "field"
  
  method tag = Codegen_common.Field

  method target_files = [ Codegen_common.Page_target ]
end

let memo : field Elements.memo = new Elements.memo
let cast (o : Elements.element_type) = CAST_OR_ERROR (memo, o, __LOCATION__)

let make depth idx (block : Common_types.parsed_block) =
  let element = Common_lib.unwrap_element block in
  let constructor parent_obj node =
    let this_obj = new field depth idx element parent_obj node in
      memo#add this_obj;
      (this_obj :> Elements.element_type) in
    Tree.Comp (constructor, Tree.null_computation)

let find t = FIND(Field)

