open Camlp4.PreCast
open Xnc_functional
open Common_types
open Codegen_common

module FC = Fragment_composer

class head depth idx parsed_element parent_obj node =
object (self)
  inherit Elements.element depth idx parsed_element parent_obj node

  val module_name = "Head"
  val class_name = "head"
  
  method tag = Codegen_common.Head

  method target_files = [ Codegen_common.Page_target ]

  method private render_page_structure comp =
    comp |> FC.append_gen ("let " ^ self#unique_id ^
                           " = new Srv_page_element.head_element in\n" ^
                           "Srv_page_structure.add_element " ^
                           "(self#get_page_structure) " ^
                           self#unique_id ^ ";\n\n") |>
    fold_left (fun el -> el#render_main_page Build_page_structure)
              self#children
end

let make_children depth sibl_num block =
  match block with
    | Proc_instr _
    | Print_proc_instr _
    | Common_types.Cdata _ -> Text_blocks.make depth sibl_num block
    | Element e -> begin
        match e.name with
          | n -> Codegen_common.unknown_element n __LOCATION__
      end

let make depth idx (block : Common_types.parsed_block) =
  let element = Common_lib.unwrap_element block in
  let constructor parent_obj node =
    let this_obj = new head depth idx element parent_obj node in
      (this_obj :> Elements.element_type) in
    Tree.Comp (constructor, make_children)

