INCLUDE "../camlp4_macros.ml"

open Camlp4.PreCast
open Xnc_functional
open Common_types
open Codegen_common

class if_invalid depth idx parsed_element parent_obj node =
object (self)
  inherit Jump_element.jump_element depth idx parsed_element parent_obj node
  
  val module_name = "If_invalid"
  val class_name = "if_invalid"

  method tag = Codegen_common.If_invalid

  method private render_page_structure comp = self#build_goto comp
end

let make_children depth sibl_num block =
  match block with
    | Proc_instr _
    | Print_proc_instr _ -> failwith "If_invalid.make_children: this exception should never appear"
    | Common_types.Cdata _ -> Text_blocks.make depth sibl_num block
    | Element e -> begin
        match e.name with
          | n -> Codegen_common.unknown_element n __LOCATION__
      end

let make depth idx (block: parsed_block) =
  let element = Common_lib.unwrap_element block in
  let constructor parent_obj node =
    let this_obj = new if_invalid depth idx element parent_obj node in
      Jump_element.jump_memo#add this_obj;
      (this_obj :> Elements.element_type) in
    Tree.Comp (constructor, make_children)

let find t = FIND_UNIQUE(If_invalid)

