open Xnc_functional
open Files_common
open Codegen_common

module FC = Fragment_composer


class main_file
  (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    FC.empty |>
    FC.set_dest_file output_file_name |>

    (* Header *)
    FC.append_gen (file_header output_file_name) |>

    (* The main file is constant *)
    FC.append_gen "module Page_dispatcher =
  Srv_page_dispatcher.Make
    (Page_parameters)
    (Page_modules.Page_state_machine)
;;

module Request_processor =
  Srv_request_processor.Make
    (Srv_runtime_context.Default_context_builder)
    (Page_modules.Server_runtime_context)
    (Page_dispatcher)
    (Page_factory_builder)
    (Resource_list_builder)
;;

module Server_main_loop =
  Srv_main_loop.Make
    (Request_processor)
;;

Server_main_loop.start();;\n\n" |>

    (* Flush the content *)
    FC.flush ~annotations:render_line_annotations
end

