open Xnc_functional
open Files_common


class main_page_file (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    (* There should be only one input file for a page *)
    let in_file = List.hd !input_file_list in
    let page = Page.find in_file#template#node in

      Fragment_composer.empty |>
      Fragment_composer.set_dest_file output_file_name |>
      Fragment_composer.set_source_file in_file#name |>
      Fragment_composer.append_gen (file_header output_file_name) |>
      page#render_main_page Codegen_common.Global_scripts |>
      page#render_main_page Codegen_common.Form_data_module |>
      page#render_main_page Codegen_common.Class_header |>
      page#render_main_page Codegen_common.Build_validators |>
      page#render_main_page Codegen_common.Class_scripts |>
      page#render_main_page Codegen_common.Build_page_structure |>
      page#render_main_page Codegen_common.Class_footer |>
      Fragment_composer.flush ~annotations:render_line_annotations
end

