open Xnc_functional
open Files_common
open Codegen_common

module FC = Fragment_composer

class ml_file
  (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    let in_file = List.hd !input_file_list in
      FC.empty |>
      FC.set_dest_file output_file_name |>
      FC.set_source_file in_file#name |>

      (* Header *)
      FC.append_gen (file_header output_file_name) |>
      FC.append_source (in_file#raw_content) 1 1 |>

      (* Flush the content *)
      FC.flush ~annotations:render_line_annotations
end

