open Xnc_functional
open Files_common
open Codegen_common

module FC = Fragment_composer

class page_factory_builder_file
  (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    FC.empty |>
    FC.set_dest_file output_file_name |>
    FC.append_gen (file_header output_file_name) |>
    FC.append_gen "type t = Page_modules.Page_factory.t

let create () =
  (* This data structure should be automatically generated *)
  let repository = Page_modules.Page_factory.create () in
  let repository = Page_modules.Page_factory.add_page_constructor
                     repository
                     \"standard_error_page.xnunc\"
                     (new Page_modules.Standard_error_page.standard_error_page) in
  let repository = Page_modules.Page_factory.add_page_constructor
                     repository
                     \"standard_not_found_page.xnunc\"
                     (new Page_modules.Standard_not_found_page.standard_not_found_page) in" |>
    self#fold_on_input (fun page -> page#render_page_factory_builder_file) |>
    FC.append_gen "\n    repository\n;;\n\n" |>
    FC.flush ~annotations:render_line_annotations
end
