open Xnc_functional
open Files_common

module FC = Fragment_composer


class page_modules_file
  (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    FC.empty |>
    FC.set_dest_file output_file_name |>

    (* Header *)
    FC.append_gen (file_header output_file_name) |>

    (* The page modules file is constant *)
    FC.append_gen "module Server_runtime_context =
  Srv_runtime_context.Make
    (Xnc_core.Null_mutex)
    (Xnc_scheduler.Null)
;;

module Page_state =
  Srv_page_state.Make
    (Server_runtime_context)
    (Session_data)
    (Page_parameters)
;;

module Page_behavior =
  Srv_page_behavior.Make
    (Page_state)
;;

module Standard_error_page =
  Srv_standard_error_page.Make
    (Page_parameters)
    (Page_behavior)
;;

module Standard_not_found_page =
  Srv_standard_not_found_page.Make
    (Page_parameters)
    (Page_behavior)
;;

module Page_factory =
  Page_behavior.Factory
;;

module Page_state_machine =
  Srv_page_state_machine.Make
    (Page_behavior)
;;\n\n" |>

    (* Flush the content *)
    FC.flush ~annotations:render_line_annotations
end

