open Xnc_functional
open Files_common
open Codegen_common

module FC = Fragment_composer

class resource_list_builder_file
  (output_file_name : string) =
object (self)
  inherit generated_file output_file_name

  method private really_render =
    FC.empty |>
    FC.set_dest_file output_file_name |>

    (* Header *)
    FC.append_gen (file_header output_file_name) |>

    (* Start building the first part of the resources list *)
    FC.append_gen "type t = Srv_resource_list.t

let create () =
  Srv_resource_list.create
    [
      { Srv_resource_list.name = \"standard_error_page.xnunc\";
        Srv_resource_list.resource_type = \"xnc:page\"
      };\n" |>

    (* Render each resource *)
    self#fold_on_input (fun page -> page#render_resource_list_builder_file) |>
    FC.append_gen "    ]\n;;\n\n" |>

    (* Flush the content *)
    FC.flush ~annotations:render_line_annotations
end

